<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>WarpTree: src/warptreeview_p.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.0 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="annotated.html"><span>Classes</span></a></li>
    <li id="current"><a href="files.html"><span>Files</span></a></li>
  </ul></div>
<h1>src/warptreeview_p.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/* This file is part of WarpTree</span>
<a name="l00002"></a>00002 <span class="comment"> *</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2007 Jos van den Oever &lt;jos@vandenoever.info&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment"> * License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment"> * version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment"> * Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the GNU Library General Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this library; see the file COPYING.LIB.  If not, write to</span>
<a name="l00017"></a>00017 <span class="comment"> * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,</span>
<a name="l00018"></a>00018 <span class="comment"> * Boston, MA 02110-1301, USA.</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 <span class="preprocessor">#include "warptreeview.h"</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include "modelnode.h"</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include "labelfitter.h"</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;QtCore/QTime&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;QtCore/QTimer&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;QtCore/QTimeLine&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">/*</span>
<a name="l00028"></a>00028 <span class="comment"> * Private class that does the actual work of displaying the WarpTree</span>
<a name="l00029"></a>00029 <span class="comment"> */</span>
<a name="l00030"></a>00030 <span class="keyword">class </span>WarpTree : <span class="keyword">public</span> QWidget {
<a name="l00031"></a>00031 Q_OBJECT
<a name="l00032"></a>00032 <span class="keyword">public</span>:
<a name="l00033"></a>00033     <span class="comment">// data members</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035     <span class="comment">// reference to the public and private classes of WarpTreeView</span>
<a name="l00036"></a>00036     <a class="code" href="classWarpTreeView.html">WarpTreeView</a>&amp; view;
<a name="l00037"></a>00037     WarpTreeView::Private&amp; viewp;
<a name="l00038"></a>00038     <span class="comment">// pointer to the nodepainter that paints background, nodes and lines</span>
<a name="l00039"></a>00039     <a class="code" href="classWarpNodePainter.html">WarpNodePainter</a>* nodepainter;
<a name="l00040"></a>00040     <span class="comment">// timer used for loading incomplete nodes in the main thread</span>
<a name="l00041"></a>00041     <span class="comment">// (it must be done in the main thread because models are not threadsafe</span>
<a name="l00042"></a>00042     <span class="comment">// in general)</span>
<a name="l00043"></a>00043     QTimer loadTimer;
<a name="l00044"></a>00044     <span class="comment">// timeline for the animation</span>
<a name="l00045"></a>00045     QTimeLine animationTimeLine;
<a name="l00046"></a>00046     <span class="comment">// start- and endpoint of the animation</span>
<a name="l00047"></a>00047     WarpCoord start, end;
<a name="l00048"></a>00048     <span class="comment">// boolean that determines if the widget is drawn antialiased</span>
<a name="l00049"></a>00049     <span class="keywordtype">bool</span> antialias;
<a name="l00050"></a>00050 
<a name="l00051"></a>00051     WarpTree(<a class="code" href="classWarpTreeView.html">WarpTreeView</a>&amp; v, WarpTreeView::Private&amp; p)
<a name="l00052"></a>00052             :view(v), viewp(p), antialias(true) {
<a name="l00053"></a>00053         <span class="comment">// construct a default painter that fits with the palette</span>
<a name="l00054"></a>00054         nodepainter = <span class="keyword">new</span> <a class="code" href="classWarpNodePainter.html">WarpNodePainter</a>(<span class="keyword">this</span>);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056         <span class="comment">// initialize the load timer to load more data in intervals of 100 ms</span>
<a name="l00057"></a>00057         loadTimer.setSingleShot(<span class="keyword">true</span>);
<a name="l00058"></a>00058         loadTimer.setInterval(100);
<a name="l00059"></a>00059         connect(&amp;loadTimer, SIGNAL(timeout()), <span class="keyword">this</span>, SLOT(loadMore()));
<a name="l00060"></a>00060 
<a name="l00061"></a>00061         <span class="comment">// initialize the animation timer</span>
<a name="l00062"></a>00062         animationTimeLine.setDuration(500);
<a name="l00063"></a>00063         connect(&amp;animationTimeLine, SIGNAL(valueChanged(qreal)),
<a name="l00064"></a>00064             <span class="keyword">this</span>, SLOT(step(qreal)));
<a name="l00065"></a>00065     }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067     <span class="comment">// paint the widget</span>
<a name="l00068"></a>00068     <span class="keywordtype">void</span> paintEvent(QPaintEvent*);
<a name="l00069"></a>00069     <span class="comment">// paint one node by calling the node painter</span>
<a name="l00070"></a>00070     <span class="keywordtype">void</span> paintNode(QPainter&amp;, <span class="keyword">const</span> ModelNode*);
<a name="l00071"></a>00071     <span class="comment">// paint the line connecting this node to its parent, if one of the two</span>
<a name="l00072"></a>00072     <span class="comment">// is visible</span>
<a name="l00073"></a>00073     <span class="keywordtype">void</span> paintParentLine(QPainter&amp; painter, <span class="keyword">const</span> ModelNode* node);
<a name="l00074"></a>00074     <span class="comment">// descent into the hierarchy and draw lines that connect to all visible</span>
<a name="l00075"></a>00075     <span class="comment">// nodes</span>
<a name="l00076"></a>00076     <span class="keywordtype">void</span> paintChildLines(QPainter&amp; painter, <span class="keyword">const</span> ModelNode* node,
<a name="l00077"></a>00077         <span class="keyword">const</span> ModelNode* notnode);
<a name="l00078"></a>00078     <span class="comment">// perform a smooth animation starting from the current position to t</span>
<a name="l00079"></a>00079     <span class="keywordtype">void</span> animateTo(<span class="keyword">const</span> WarpCoord&amp; t);
<a name="l00080"></a>00080 <span class="keyword">public</span> slots:
<a name="l00081"></a>00081     <span class="comment">// when not all visible nodes have been completely loaded this slot is</span>
<a name="l00082"></a>00082     <span class="comment">// called</span>
<a name="l00083"></a>00083     <span class="keywordtype">void</span> loadMore();
<a name="l00084"></a>00084     <span class="comment">// perform one step in the animation</span>
<a name="l00085"></a>00085     <span class="keywordtype">void</span> step(qreal value);
<a name="l00086"></a>00086 };
<a name="l00087"></a>00087 <span class="keyword">class </span>WarpTreeView::Private {
<a name="l00088"></a>00088 <span class="keyword">public</span>:
<a name="l00089"></a>00089     <span class="comment">// the tree widget that does the drawing</span>
<a name="l00090"></a>00090     WarpTree tree;
<a name="l00091"></a>00091     <span class="comment">// all the nodes that have been loaded</span>
<a name="l00092"></a>00092     QHash&lt;QModelIndex, ModelNode*&gt; nodes;
<a name="l00093"></a>00093     <span class="comment">// a subset of all nodes, namely all nodes that have their center visible</span>
<a name="l00094"></a>00094     QList&lt;ModelNode*&gt; visibleNodes;
<a name="l00095"></a>00095     <span class="comment">// the list of nodes that are currently visible and need to be loaded</span>
<a name="l00096"></a>00096     QList&lt;ParentModelNode*&gt; todo;
<a name="l00097"></a>00097     <span class="comment">// the helper class that fits the labels into the view</span>
<a name="l00098"></a>00098     LabelFitter labelfitter;
<a name="l00099"></a>00099     <span class="comment">// a reference to the public part</span>
<a name="l00100"></a>00100     <a class="code" href="classWarpTreeView.html">WarpTreeView</a>&amp; view;
<a name="l00101"></a>00101     <span class="comment">// the root of the model</span>
<a name="l00102"></a>00102     QPersistentModelIndex root;
<a name="l00103"></a>00103     <span class="comment">// the point on the unit square that corresponds to the current position</span>
<a name="l00104"></a>00104     WarpCoord origin;
<a name="l00105"></a>00105     <span class="comment">// the start from where the user started a drag action</span>
<a name="l00106"></a>00106     WarpCoord dragStart;
<a name="l00107"></a>00107     <span class="comment">// the origin corresponding to the position from which the drag started</span>
<a name="l00108"></a>00108     WarpCoord dragStartOrigin;
<a name="l00109"></a>00109     <span class="comment">// a pointer to the node that is currently being hovered by the mouse</span>
<a name="l00110"></a>00110     ModelNode* hoverNode;
<a name="l00111"></a>00111     <span class="comment">// a pointer to the previous node that was hovered by the mouse</span>
<a name="l00112"></a>00112     ModelNode* lastHoverNode;
<a name="l00113"></a>00113     <span class="comment">// a pointer to the active node, the node closest to the center of the view</span>
<a name="l00114"></a>00114     ModelNode* activeNode;
<a name="l00115"></a>00115     <span class="comment">// the zoomfactor of the view</span>
<a name="l00116"></a>00116     <span class="keywordtype">float</span> zoomFactor;
<a name="l00117"></a>00117     <span class="comment">// a boolean that is set when we are in a drag action</span>
<a name="l00118"></a>00118     <span class="keywordtype">bool</span> movedSinceClick;
<a name="l00119"></a>00119 
<a name="l00120"></a>00120     Private(<a class="code" href="classWarpTreeView.html">WarpTreeView</a>&amp; v) :tree(v, *this), view(v), hoverNode(0),
<a name="l00121"></a>00121         lastHoverNode(0), activeNode(0), zoomFactor(1), movedSinceClick(false) {
<a name="l00122"></a>00122     }
<a name="l00123"></a>00123     ~Private() {
<a name="l00124"></a>00124         foreach(ModelNode* n, nodes) {
<a name="l00125"></a>00125             <span class="keyword">delete</span> n;
<a name="l00126"></a>00126         }
<a name="l00127"></a>00127     }
<a name="l00128"></a>00128     <span class="comment">/* equivalents to the public functions in WarpTreeView that</span>
<a name="l00129"></a>00129 <span class="comment">       contain the actual implementation */</span>
<a name="l00130"></a>00130     <span class="keywordtype">void</span> <a class="code" href="classWarpTreeView.html#71e50115c559122afe5305090a52c7ab">setModel</a>(QAbstractItemModel* model);
<a name="l00131"></a>00131     <span class="keywordtype">void</span> <a class="code" href="classWarpTreeView.html#8bc9bead25adb3db495315ae8b11a22e">mouseMoveEvent</a>(QMouseEvent* event);
<a name="l00132"></a>00132     <span class="keywordtype">void</span> <a class="code" href="classWarpTreeView.html#de01ba1756c94f3fd158c23b38e0d0c0">mousePressEvent</a>(QMouseEvent* event);
<a name="l00133"></a>00133     <span class="keywordtype">void</span> <a class="code" href="classWarpTreeView.html#f5392d0f8bc5364fe1d5be54bf522759">mouseReleaseEvent</a>(QMouseEvent* event);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135     <span class="comment">/* functions for moving the view */</span>
<a name="l00136"></a>00136     <span class="comment">// change the origin of the view and translate all the points in the graph</span>
<a name="l00137"></a>00137     <span class="keywordtype">void</span> setOrigin(<span class="keyword">const</span> WarpCoord&amp; o);
<a name="l00138"></a>00138     <span class="comment">// update the screen coordinates and determine which labels to display</span>
<a name="l00139"></a>00139     <span class="keywordtype">void</span> updateScreenCoords();
<a name="l00140"></a>00140     <span class="comment">// two functions that will later help speedup the view</span>
<a name="l00141"></a>00141     <span class="comment">//void translateParent(const ModelNode* node);</span>
<a name="l00142"></a>00142     <span class="comment">//void translateChildren(const ModelNode* node, const ModelNode* notnode);</span>
<a name="l00143"></a>00143     <span class="comment">// start dragging the view at the given screen coordinates</span>
<a name="l00144"></a>00144     <span class="keywordtype">void</span> startDrag(<span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y);
<a name="l00145"></a>00145     <span class="comment">// drag the view to the given screen coordinates</span>
<a name="l00146"></a>00146     <span class="keywordtype">void</span> drag(<span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y);
<a name="l00147"></a>00147     <span class="comment">// change the zoom factor with a factor f</span>
<a name="l00148"></a>00148     <span class="keywordtype">void</span> zoom(<span class="keywordtype">float</span> f);
<a name="l00149"></a>00149     <span class="comment">// animate the view from the current positions to the position given in</span>
<a name="l00150"></a>00150     <span class="comment">// screen coordinates</span>
<a name="l00151"></a>00151     <span class="keywordtype">void</span> animateTo(<span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y);
<a name="l00152"></a>00152     <span class="comment">// move the view by the distance given in screen coordinates</span>
<a name="l00153"></a>00153     <span class="keywordtype">void</span> move(<span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y);
<a name="l00154"></a>00154     <span class="comment">// find the node that displays a label at position pos</span>
<a name="l00155"></a>00155     ModelNode* findNode(<span class="keyword">const</span> QPoint&amp; pos);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157     <span class="comment">/* functions for loading the nodes */</span>
<a name="l00158"></a>00158     <span class="comment">// load the nodes from the todo list</span>
<a name="l00159"></a>00159     <span class="keywordtype">void</span> loadMore();
<a name="l00160"></a>00160     <span class="comment">// load the children of a node and layout the node</span>
<a name="l00161"></a>00161     <span class="keywordtype">void</span> completeNode(ParentModelNode* n);
<a name="l00162"></a>00162     <span class="comment">// add one node and determine the size of its label,</span>
<a name="l00163"></a>00163     <span class="comment">// but do not yet layout or load the children</span>
<a name="l00164"></a>00164     ModelNode* addNode(<span class="keyword">const</span> QModelIndex&amp; index,
<a name="l00165"></a>00165         ParentModelNode* parent, <span class="keywordtype">int</span> depth);
<a name="l00166"></a>00166     <span class="comment">// determine which of the labels of the dynamically loaded nodes to show</span>
<a name="l00167"></a>00167     <span class="keywordtype">void</span> filterChildrenVisible(<span class="keyword">const</span> QVector&lt;ModelNode*&gt;&amp; nodes);
<a name="l00168"></a>00168 };
</pre></div><hr size="1"><address style="align: right;"><small>Generated on Sat Jun 2 19:18:06 2007 for WarpTree by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.0 </small></address>
</body>
</html>
